//methods for handling the toolbar
unit toolbar;

interface

uses windows,controls,sysutils,barutil,CommCtrl,SuppletOpts,textdata;

type
  BtnEx= record
    tbBtn:TTBButton;    //Button itself
    internalPos:integer;//Position assigned when added to Toolbar
    realPos:integer;    //Position assigned by User
    end;

function  NotifyProc(hwndTB:Hwnd;wPar:WParam;lPar:LParam;Rebar:HWND;caller:Pointer):LResult;
procedure addMyButtons(hwndTB:HWND;language:integer);
procedure initButtons;
procedure setMarkerButton(hwndtb:hwnd;what:wordbool);
procedure setNoteButton(hwndtb:hwnd;what:wordbool);

const

  True: wordbool=(1=1);
  False:wordbool=(1=2);

implementation

uses
  mark,
//just temporary for debug:
  Dialogs, Messages,
  ActiveX, ComObj, ComServ,
  Forms,Registry, MSHTML_TLB, SHDocVw_TLB, SHLOBJ;

threadvar
//  ImageIndex:LResult;
  myBtns:array[0..2]of BtnEx; //buttons
  hImg:HIMAGELIST;  //to see if button size changed
  lang:integer;

{
//disabled at the moment, but TODO: return intelligent Help here
//to activy just remove comments in NotifyProc!
function getInfoTip(forWhat:integer):String;
begin
Result:=loadString(hInstance, myBtns[forWhat].tbBtn.idCommand
end;
}

procedure saveBtnPos;
var
  tempInt:integer;
  tempInt2:integer;
  tempVal:integer;
begin
for tempInt:=0 to length(myBtns)-1 do
  begin
  tempVal:=myBtns[tempInt].realPos;
  for tempInt2:=tempInt+1 to length(myBtns)-1 do
    if(myBtns[tempInt2].realPos<myBtns[tempInt].realPos)then
      dec(tempVal);
  saveButton(tempInt,tempVal);
  end;
end;

//adds one Button;
//hwndTB: Toolbarhandle, id: ResourceID, position: pos to add, or -1 to add to end
function addBut(lang:integer;hwndTB:HWND;cmd:integer;state:integer;style:integer;var internalPos:integer;var realPos:integer): TTBButton;
var
  ImageIndex:integer;
  TextIndex:integer;
  myBtn:TTBButton;

begin
if(cmd<>0)then //if not a seperator
  begin
  hImg:=SendMessage(hwndTB,TB_GETHOTIMAGELIST,0,0);
  ImageList_AddIcon(hImg,LoadIcon(HInstance,MAKEINTRESOURCE(cmd+1)));
  hImg:=SendMessage(hwndTB,TB_GETIMAGELIST,0,0);
  ImageIndex:=ImageList_AddIcon(hImg,LoadIcon(HInstance,MAKEINTRESOURCE(cmd)));
  //MessageDlg('ImageIndex'+inttostr(ImageIndex)+' for cmd:'+inttostr(cmd),mtInformation,[mbOk], 0);
  TextIndex:=sendMessage(hwndtb,TB_ADDSTRING,hinstance,MAKELONG (lang+cmd, 0));
  end
else
  begin
  ImageIndex:=0;
  TextIndex:=-1;
  end;
ZeroMemory(@myBtn,sizeof(TTBButton));
with myBtn do
  begin
  iBitmap:=ImageIndex;//I_IMAGECALLBACK;//ImageIndex;
  idCommand:=cmd;
  fsState:=state;
  fsStyle:=style; //TBSTYLE_BUTTON or TBSTYLE_CHECK;// or TBSTYLE_DROPDOWN;
  iString:=TextIndex;
  end;
case realpos of
 -2:  //add to the end of toolbar
  begin
  SendMessage(hwndtb,TB_INSERTBUTTON,WPARAM(999),LPARAM(@myBtn));
  internalPos:=SendMessage(hwndTB,TB_COMMANDTOINDEX,WParam(cmd),0); //get actual position
//  realPos:=internalPos;
  end;
 -1:  //not on the bar
  begin
  SendMessage(hwndtb,TB_INSERTBUTTON,WPARAM(internalPos),LPARAM(@myBtn));
  internalPos:=SendMessage(hwndTB,TB_COMMANDTOINDEX,WParam(cmd),0); //get actual position
  SendMessage(hwndTB,TB_DELETEBUTTON,internalPos,LParam(0)); //
{MessageDlg('intPos'+inttostr(myBtns[0].internalPos)+' realPos:'+inttostr(myBtns[0].realPos)+' bar says:'+inttostr(SendMessage(hwndTB,TB_COMMANDTOINDEX,WParam(myBtns[0].tbBtn.idCommand),0)),mtInformation,[mbOk], 0);
MessageDlg('intPos'+inttostr(myBtns[1].internalPos)+' realPos:'+inttostr(myBtns[1].realPos)+' bar says:'+inttostr(SendMessage(hwndTB,TB_COMMANDTOINDEX,WParam(myBtns[1].tbBtn.idCommand),0)),mtInformation,[mbOk], 0);
MessageDlg('intPos'+inttostr(myBtns[2].internalPos)+' realPos:'+inttostr(myBtns[2].realPos)+' bar says:'+inttostr(SendMessage(hwndTB,TB_COMMANDTOINDEX,WParam(myBtns[2].tbBtn.idCommand),0)),mtInformation,[mbOk], 0);
}  end
 else
  begin
  SendMessage(hwndtb,TB_INSERTBUTTON,WPARAM(realPos),LPARAM(@myBtn));
  internalPos:=SendMessage(hwndTB,TB_COMMANDTOINDEX,WParam(cmd),0);
  realPos:=internalPos;
  end;
 end;
Result:=myBtn;
end;

//returns the Arrayindex of matching button or -1 if none matches
function getByInternalPos(iItem:integer):integer;
var
  tempInt:integer;
begin
for tempInt:=0 to length(myBtns)-1 do
  if(iItem=myBtns[tempInt].internalPos)then
    begin
    Result:=tempInt;
    exit;
    end;
Result:=-1;
end;

//returns the Arrayindex of matching button or -1 if none matches
function getByCmd(iItem:integer):integer;
var
  tempInt:integer;
begin
for tempInt:=0 to length(myBtns)-1 do
  if(iItem=myBtns[tempInt].tbBtn.idCommand)then
    begin
    Result:=tempInt;
    exit;
    end;
Result:=-1;
end;

function NotifyProc(hwndTB:Hwnd;wPar:WParam;lPar:LParam;Rebar:HWND;caller:Pointer):LResult;
var
  toolI:PNMTOOLBARW;
  tempImg:HIMAGELIST;  //to see if button size changed
//  TippIAnsi:PNMTBGetInfoTipA; //might be used to get intelligent
//  TippI:PNMTBGetInfoTipW;     //Button Tipps lateron
  tempInt:Integer;
  pt:TPoint;
  Rect:TRect;

begin
Result:=-1;
    case PNMToolBar(lPar)^.hdr.code of
      TBN_DROPDOWN:
        begin
        toolI:=Pointer(lPar);
        if(getByCmd(toolI.iItem)<>-1)then
          begin
          if(SendMessage(hwndTB,TB_GETRECT,toolI.iItem,LPARAM(@Rect))=0)then
            exit;
          pt.x := Rect.Left;
          pt.y := Rect.Bottom;
          ClientToScreen(toolI.hdr.hwndFrom, pt);
          showSuppletPopup(Rebar,pt);
          Result:=TBDDRET_DEFAULT;
          end;
        end;
      TBN_QUERYINSERT,TBN_QUERYDELETE:
        begin
        toolI:=Pointer(lPar);
        if(getByInternalPos(tooli.iItem)<>-1)then
          begin
          Result:=LResult(true);
          exit;
          end;
        end;
      TBN_DELETINGBUTTON:
        begin
        toolI:=Pointer(lPar);
        if(getByCmd(tooli.iItem)<>-1)then
          begin
          Result:=LResult(true);
          exit;
          end;
        end;
{Remove comment here to allow for intelligent ButtonTipps
      TBN_GETINFOTIPW:
        begin
        TippI:=Pointer(lPar);
        tempInt:=getByCmd(TippI.iItem);
        if(tempInt<>-1)then
          begin
          StringToWideChar(getInfoTip(tempInt),TippI.pszText,TippI.cchTextMax);
          end;
        end;
}
      TBN_GETBUTTONINFOA,TBN_GETBUTTONINFOW:
        begin
        toolI:=Pointer(lPar);
        tempInt:=getByInternalPos(tooli.iItem);
        if(tempInt<>-1)then
          begin
          toolI.tbButton:=myBtns[tempInt].tbBtn;
          toolI.cchText:=0;//length(texti);
          Result:=LResult(true);
          exit;
          end;
        end;
      TBN_TOOLBARCHANGE:
        begin
        for tempint:=0 to length(myBtns)-1 do
           myBtns[tempInt].realPos:=SendMessage(hwndTB,TB_COMMANDTOINDEX,WParam(myBtns[tempInt].tbBtn.idCommand),0);
        saveBtnPos;
        end;
      TBN_RESET,TBN_BEGINADJUST,TBN_ENDADJUST:
        begin
        if(PNMToolBar(lPar)^.hdr.code=TBN_RESET)then
          begin
          himg:=0;
          for tempint:=0 to length(myBtns)-1 do
            myBtns[tempInt].realPos:=-2;
          saveBtnPos;
          end;
        tempImg:=SendMessage(hwndTB,TB_GETIMAGELIST,0,0);
        if(tempImg<>hImg)then //ButtonSize changed, reinstall yourself
          begin
          addMyButtons(hwndTB,lang);
{          if(PNMToolBar(lPar)^.hdr.code=TBN_RESET)then
            begin
            saveBtnPos;
            end
          else
            addMyButtons(hwndTB);}
          himg:=tempImg;
          end;
        end;
      end;
end;

procedure addMyButtons(hwndTB:HWND;language:integer);
var
  tempInt:integer;
  firsttime:boolean;
begin
if(language<>0)then
  lang:=language;
SendMessage(hwndTB,TB_BUTTONSTRUCTSIZE,sizeof(TTBBUTTON),0);
firsttime:=true;
for tempInt:=0 to length(myBtns)-1 do
  if(myBtns[tempInt].realPos<>-2)then
    firsttime:=false;
if(firsttime)then
  begin
  tempInt:=-2;
  addBut(lang,hwndTB,0,TBSTATE_ENABLED,TBSTYLE_SEP,tempInt,tempInt);
  end;
for tempInt:=0 to length(myBtns)-1 do
  begin
  myBtns[tempInt].internalPos:=tempInt+1;
  myBtns[tempInt].tbBtn:=addBut(lang,hwndTB,myBtns[tempInt].tbBtn.idCommand,myBtns[tempInt].tbBtn.fsState,myBtns[tempInt].tbBtn.fsStyle,myBtns[tempInt].internalPos,myBtns[tempInt].realPos);
  end;
if(firsttime)then
  saveBtnPos;
end;

procedure initButtons;
var
  tempInt:integer;
begin
for tempInt:=0 to length(myBtns)-1 do
  myBtns[tempInt].realPos:=loadButton(tempInt);
with myBtns[0].tbBtn do
  begin
  fsState:=TBSTATE_ENABLED;
  fsStyle:=TBSTYLE_BUTTON or TBSTYLE_CHECK;
  idCommand:=TB_DOMARKER;
  end;
with myBtns[1].tbBtn do
  begin
  fsState:=TBSTATE_ENABLED;
  fsStyle:=TBSTYLE_BUTTON or TBSTYLE_CHECK;
  idCommand:=TB_DONOTE;
  end;
with myBtns[2].tbBtn do
  begin
  fsState:=TBSTATE_ENABLED;
  fsStyle:=TBSTYLE_BUTTON or TBSTYLE_DROPDOWN;
  idCommand:=TB_DOSHEET;
  end;
end;

procedure setMarkerButton(hwndtb:hwnd;what:wordbool);
begin
SendMessage(hwndTB,TB_CHECKBUTTON,WParam(myBtns[0].tbBtn.idCommand),LParam(MakeLong(word(what),0)));
end;

procedure setNoteButton(hwndtb:hwnd;what:wordbool);
begin
SendMessage(hwndTB,TB_CHECKBUTTON,WParam(myBtns[1].tbBtn.idCommand),LParam(MakeLong(word(what),0)));
end;


end.
